c Decimates data
c
c  specify input time series
c
c  compute a running median (not running mean)
c    after specifying the period
c  
c  decimate at interval corresponding to averaging interval
c
c  Modify decimate_1;  you now have a choice whether to decimate using medians or MEANS
c
c  Modified with feature to simple decimate by "down sampling",
c

      character*20 ifile,ofile

      dimension d(3500000),e(3500000),dsrt(3500000),r(3500000),
     &  fmed(3500000)
      integer year(3500000),mn(3500000)
      double precision fjul,fday,tsam_day,time0,time,day(3500000)
      fmiss=9999999.
      
      nmax=3500000
      do 1 i=1,nmax
      r(i)=fmiss
1     d(i)=fmiss
      print*,' Input the type of date format'
      print*,'   year julian   put 1'
      print*,'  year month day put 2'
      read(5,*)ifor
      print*,' Input file to examine'
      print*,'   input format is year, julian day, data, data_error'
      read(5,100)ifile
100   format(a20)
      open(1,file=ifile)
      print*,' Input name of output file'
      read(5,100)ofile
      open(4,file=ofile)
      print*,' Input sampling interval in days'
      print*,'   1--hour = ',1./24.d+0
      print*,'   10--minutes =',10./(24.d+0 * 60.0d+0)
      print*,'   1--minute = ',1.0/(24.d+0 * 60.0d+0)
      print*,'   1--second =', 1.0/(24.d+0 * 3600.0d+0)
      read(5,*)tsam_day
      print*,'  Type of decimation'
      print*,'  1 =  Median'
      print*,'  2 = Running Mean'
      print*,'  3 = Down Sampling'
      read(5,*)itype
      n=0
      ic=0
2     continue
      if (ifor .eq. 1) then
        read(1,*,end=3)yr,fjul,obs,err

        call jul2day(int(yr+0.5),int(fjul+0.5),iday)


        time=float(iday)+fjul-float(int(fjul+0.5))
        if (n .eq. 0) time0=time
        n=int(((time-time0)/tsam_day)+0.5)+1
        ic=ic+1
        year(n)=yr
        day(n)=fjul

c        print*,n,n+1,year(n+1),fjul,day(n+1)


      end if
      if (ifor .eq. 2) then
        read(1,*,end=3)yr,fmn,fday,obs,err
        call  date2day(int(yr),int(fmn),int(fday+0.5),iday)
        time=float(iday)+fday-float(int(fday+0.5))
        if (n .eq. 0) time0=time

        n=int(((time-time0)/tsam_day)+0.5)+1
        ic=ic+1
        year(n)=yr
        mn(n)=int(fmn)
        day(n)=fday

      end if
c      write(2,*)n,time(n)

      d(n)=obs
      dsrt(ic)=obs
      e(n)=err
c        write(10,*)n,yr,fjul,obs,time,year(n),day(n),d(n)
c      print*,year,fjul,time,ic,n,time-time0,(time-time0)/tsam_day

      if (n .ge. nmax) then
         print*,' Number of observations exceed dimensions'
         print*,'  nmax=',nmax,'  n=',n
         print*,n,yr,fjul,obs,time,year(n),day(n),d(n)

         stop
      end if
      
      go to 2
3     continue
     
      print*,' number of data',ic
      print*,' Total number of days ',n*tsam_day




c      xmed=fmedian(ic,dsrt)
c      print*,' the median is: ', xmed
c      do 12 i=1,n
c      if (d(i) .ne. fmiss) r(i)=d(i)-xmed
c12    continue
      tstart=0
c      do 13 i=1,5
c
c        dsrt(i)=d(i)
c13    continue
c      call piksrt(5,dsrt)
c      dstart=dsrt(3)

c      do 14 i=1,5


c        dsrt(i)=dsrt(ic+1-i)
c14    continue
c      call piksrt(5,dsrt)
c      dstop=dsrt(3)

c      rate=(dstop-dstart)/(float(n)*tsam_day)
c      print*, ' rate is in units /yr: ',rate*365.
c      print*,'  rate is in units / day: ',rate
c      do 15 i=1,n
c      if (d(i) .ne. fmiss) r(i)=r(i)-rate*float(i)*tsam_day
c15    continue

      print*,' Input the window length in days to compute running ',
     & 'median/mean and the DECIMATION interval'

      read(5,*)per
      nwind=int(per/tsam_day+0.5)
      print*,'  Number of points in window', nwind
      n_tot_wind=int(n/nwind)
      print*,'  Total number of windows is', n_tot_wind+1
c
c  compute medians of windows of data with length per 
c
c      istart=1
c      istop=istart+nwind-1
      do 20 k=1,n_tot_wind
      istart=k*nwind-nwind+1
      istop=k*nwind
      ix=0
        do 21 i=istart,istop

           if (d(i) .ne. fmiss) then
           ix=ix+1
           dsrt(ix)=d(i)
           end if
21      continue
        if (itype .eq. 1 ) xmed=fmedian(ix,dsrt)
        if (itype .eq. 2 ) xmed=fave(ix,dsrt)
        if (itype .eq. 3 ) xmed=d(istart)

        fmed(k)=xmed
c        print*,istart,istop,ix,xmed
        if (ix .ne. 0) then
        if ( ifor .eq. 1 ) then
          if ( itype .ne. 3) then
          nave=int(((istart+istop)/2)+0.5)
          else
          nave=istart
          end if

          time=time0+tsam_day*float(nave-1)
          iitime=int(time)

          call inv_jul_time(iitime,iyr,ijul)
          fjul=float(ijul)+time-float(iitime)
          if (fmed(k) .ne. fmiss) then
          write(4,101)iyr,fjul,fmed(k),ix

          end if
101       format(i6,f20.9,f12.3,i10)



        end if
        if ( ifor .eq. 2 ) then
c  this is not working; need subroutine to convert day number to calendar day
          nave=int(((istart+istop)/2)+0.5)

          time=time0+tsam_day*float(nave-1)
          iitime=int(time)

          call inv_jul_time(iitime,iyr,ijul)
          fjul=float(ijul)+time-float(iitime)
          write(4,101)iyr,fjul,fmed(k),ix


c          write(4,102)year(i),mn(i),day(i),fmed(k),e(i)
c102       format(i6,i6,f20.9,f7.1,f4.1)

        end if
        end if
c   remove running median
c        do 22 i=istart,istop
c        if (r(i) .ne. fmiss) r(i)=r(i)-xmed
c22      continue
20    continue
c  same as above but for the last window
        istart=istop+1
        istop=n
        ix=0
        do 23 i=istart,istop
          if (d(i) .ne. fmiss) then
          ix=ix+1
          dsrt(ix)=d(i)
          end if
23      continue
c        xmed=fmedian(ix,dsrt)
        if (itype .eq. 1 ) xmed=fmedian(ix,dsrt)
        if (itype .eq. 2 ) xmed=fave(ix,dsrt)
        if (itype .eq. 3) xmed=d(istart)
        fmed(n_tot_wind+1)=xmed
c        print*,istart,istop,ix,xmed
        if (ix .ne. 0) then
        if (( ifor .eq. 1 ) .or. (ifor .eq. 2)) then
c          nave=int(((istart+istop)/2)+0.5)
          nave=int(((istart+istart+nwind)/2)-1+0.5)
          if (itype .eq. 3) nave=istart
          time=time0+tsam_day*float(nave-1)
          iitime=int(time)

          call inv_jul_time(iitime,iyr,ijul)
          fjul=float(ijul)+time-float(iitime)
          write(4,101)iyr,fjul,fmed(k),ix




        end if
        if ( ifor .eq. 20 ) then
c        if ( ifor .eq. 2 ) then
c  this is not working; need subroutine to convert day number to calendar day
          nave=int(((istart+istop)/2)+0.5)

          time=time0+tsam_day*float(nave-1)
          iitime=int(time)

          call inv_jul_time(iitime,iyr,ijul)
          fjul=float(ijul)+time-float(iitime)
          write(4,101)iyr,fjul,fmed(k),ix


c          write(4,102)year(i),mn(i),day(i),fmed(k),e(i)
c102       format(i6,i6,f20.9,f7.1,f4.1)

        end if
        end if
c        do 24 i=istart,istop
c        if (r(i) .ne. fmiss) r(i)=r(i)-xmed
c24      continue
c
c   sort the data to get statistics on data
c
      ix=0
      do 30 i=1,n
      if (d(i) .ne. fmiss) then
        ix=ix+1
        dsrt(ix)=d(i)
      end if
30    continue
      print*,"  Number of missing observations is ",n-ix
      call hpsort(ix,dsrt)
c      print*," Minimum value ",1,dsrt(1)
c      print*," Maximum value ",ix,dsrt(ix)
      print*," Extreme values ",dsrt(1),dsrt(ix),
     & " distance = ",dsrt(ix)-dsrt(1)
      n75=int(0.125*ix)
      print*," 75% interval",dsrt(n75),dsrt(ix-n75+1),
     & " distance= ",dsrt(ix-n75+1)-dsrt(n75)
      n90=int(0.05*ix)
      print*," 90% interval",dsrt(n90),dsrt(ix-n90+1),
     & " distance= ",dsrt(ix-n90+1)-dsrt(n90)
      n95=int(0.025*ix)      
      print*," 95% interval",dsrt(n95),dsrt(ix-n95+1),
     & " distance= ",dsrt(ix-n95+1)-dsrt(n95)
      n99=int(0.005*ix)
      print*," 99% interval",dsrt(n99),dsrt(ix-n99+1),
     & " distance= ",dsrt(ix-n99+1)-dsrt(n99) 
      n999=int(0.0005*ix)
      print*," 99.9% interval",dsrt(n999),dsrt(ix-n999+1),
     & " distance= ",dsrt(ix-n999+1)-dsrt(n999) 

      close (1)
      close (4)

      stop
      end

      function fmedian(n,arr)
      real arr(n)
c      print*,arr(1),arr(n),arr(54),arr(55)
c      if ((float(n)/2. - int(n/2)) .eq. 0.5) then
c        print*,int(n/2+1.5), int(float(n)/2.+0.5), '  odd'
        nx=int(float(n)/2.+0.5)
c        print*,' nx=',nx, ' n=',n, arr(1),arr(n)
        fmedian=select(nx,n,arr)
 
        return
c        else
c        fmedian=0.5*(arr(int(n/2))+arr(int(n/2)+1))

c        print*,(int(n/2)),(int(n/2)+1) 
c        return
c      end if
      end

      function fave(n,arr)
      real arr(n)
      fave=0.
      if (n .eq. 0) return
c        print*,' running ave not computed; n=0'
c        stop
c      end if
      do 1 i=1,n
      fave=fave+arr(i)
1     continue
      fave=fave/float(n)
      
      return
      end

      subroutine piksrt(n,arr)
c from numerical recipes
c sorts arr in ascending order
      integer n, i, j
      real arr(n), a
      do 12 j=2,n
        a=arr(j)
        do 11 i=j-1,1,-1
          if (arr(i) .le. a) go to 10
           arr(i+1)=arr(i)
11      continue
        i=0
10      arr(i+1)=a
12    continue
      return
      end
      subroutine date2day(yr,mon,date,day)
      integer yr,date,day,mon
      dimension mnth(12)
      data (mnth(i),i=1,12)/0,31,59,90,120,151,181,212,243,273,304,334/
c
      yr=yr-1900

      day=0
      day=int(yr-60)*365
      if (yr .le. 60) go to 3
      day= day+1
      if (yr .le. 64) go to 3
      day= day+1
      if (yr .le. 68) go to 3
      day= day+1
      if (yr .le. 72) go to 3
      day= day+1
      if (yr .le. 76) go to 3
      day= day+1
      if (yr .le. 80) go to 3
      day= day+1
      if (yr .le. 84) go to 3
      day=day+1
      if (yr .le. 88) go to 3
      day=day+1
      if (yr .le. 92) go to 3
      day=day+1
      if (yr .le. 96) go to 3
      day=day+1
      if (yr .le. 100) go to 3
      day=day+1     
      if (yr .le. 104) go to 3
      day=day+1     
      if (yr .le. 108) go to 3
      day=day+1     
3     day=day+mnth(mon)+date
      if (((yr .eq. 80) .or. (yr .eq. 64) .or. (yr .eq. 68) .or.
     &  (yr .eq. 72) .or. (yr .eq. 76) .or. (yr .eq. 80) .or. 
     & (yr .eq. 84) .or.(yr .eq. 88)
     &  .or. (yr .eq. 92) .or. (yr .eq. 96) .or. (yr .eq. 100)
     & .or. (yr .eq. 104) .or. (yr .eq. 108))
     1  .and. (mon .ge. 3)) go to 10
      go to 11
10    day= day+1
      
11    continue
      yr=yr+1900
      return
      end
      
      subroutine jul2day(yr,jul,iday)
      integer yr, jul, iday
      yr=yr-1900
      iday=0
      if (yr .gt. 60 ) iday=iday+1
      if (yr .gt. 64 ) iday=iday+1
      if (yr .gt. 68 ) iday=iday+1
      if (yr .gt. 72 ) iday=iday+1
      if (yr .gt. 76 ) iday=iday+1
      if (yr .gt. 80 ) iday=iday+1
      if (yr .gt. 84 ) iday=iday+1
      if (yr .gt. 88 ) iday=iday+1
      if (yr .gt. 92 ) iday=iday+1
      if (yr .gt. 96 ) iday=iday+1
      if (yr .gt. 100 ) iday=iday+1
      if (yr .gt. 104 ) iday=iday+1
      if (yr .gt. 108 ) iday=iday+1

      iday=iday+(yr-60)*365 + jul
      yr=yr+1900
      return
      end
      subroutine inv_jul_time(itime,nyr,jul)
c converts day number since jan 1, 1960 back to julian day and year
c
c  itime is number of days since Jan 1, 1960
      dimension nyear(60),nleap(60)
      nx=60
        do 1 i=1,nx
        nleap(i)=1+(i-1)*4
1       continue
        j=1
        ncnt=0
        do 2 i=1,nx
        if (i .eq. nleap(j)) then
           ncnt=ncnt+366
           j=j+1
        else
          ncnt=ncnt+365
        end if
        nyear(i)=ncnt
c        print*,i,nyear(i)
2       continue
      k=1
      nyr=1960
c      if (itime .lt. nyear(1)) then
      if (itime .le. nyear(1)) then
        jul=itime
        return
      end if
      k=2
      nyr=nyr+1
3     continue
      if ((itime .gt. nyear(k-1)) .and. (itime .le. nyear(k))) then
        jul=itime-nyear(k-1)
        return
      else
        k=k+1
        nyr=nyr+1
        go to 3
      end if
      end

      FUNCTION select(k,n,arr)
      INTEGER k,n
      REAL select,arr(n)
      INTEGER i,ir,j,l,mid
      REAL a,temp
      l=1
      ir=n
1     if(ir-l.le.1)then
        if(ir-l.eq.1)then
          if(arr(ir).lt.arr(l))then
            temp=arr(l)
            arr(l)=arr(ir)
            arr(ir)=temp
          endif
        endif
        select=arr(k)
        return
      else
        mid=(l+ir)/2
        temp=arr(mid)
        arr(mid)=arr(l+1)
        arr(l+1)=temp
        if(arr(l).gt.arr(ir))then
          temp=arr(l)
          arr(l)=arr(ir)
          arr(ir)=temp
        endif
        if(arr(l+1).gt.arr(ir))then
          temp=arr(l+1)
          arr(l+1)=arr(ir)
          arr(ir)=temp
        endif
        if(arr(l).gt.arr(l+1))then
          temp=arr(l)
          arr(l)=arr(l+1)
          arr(l+1)=temp
        endif
        i=l+1
        j=ir
        a=arr(l+1)
3       continue
          i=i+1
        if(arr(i).lt.a)goto 3
4       continue
          j=j-1
        if(arr(j).gt.a)goto 4
        if(j.lt.i)goto 5
        temp=arr(i)
        arr(i)=arr(j)
        arr(j)=temp
        goto 3
5       arr(l+1)=arr(j)
        arr(j)=a
        if(j.ge.k)ir=j-1
        if(j.le.k)l=i
      endif
      goto 1
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *1(.YaAV.
      SUBROUTINE hpsort(n,ra)
      INTEGER n
      REAL ra(n)
      INTEGER i,ir,j,l
      REAL rra
      if (n.lt.2) return
      l=n/2+1
      ir=n
10    continue
        if(l.gt.1)then
          l=l-1
          rra=ra(l)
        else
          rra=ra(ir)
          ra(ir)=ra(1)
          ir=ir-1
          if(ir.eq.1)then
            ra(1)=rra
            return
          endif
        endif
        i=l
        j=l+l
20      if(j.le.ir)then
          if(j.lt.ir)then
            if(ra(j).lt.ra(j+1))j=j+1
          endif
          if(rra.lt.ra(j))then
            ra(i)=ra(j)
            i=j
            j=j+j
          else
            j=ir+1
          endif
        goto 20
        endif
        ra(i)=rra
      goto 10
      END
C  (C) Copr. 1986-92 Numerical Recipes Software *1(.YaAV.
