c  Decimates data by "down sampling" the data
c   However, near times specified as 'important events', do not decimate the data
c  full sample for 50% of window length
c  for remaining 50%, taper sampling to the 'down sample interval'
c
c Difference between resample_1 and here (resample_2) is that in this
c   code, I do not use the highest sampling interval at the start and end
c   of the data
      character*20 ifile,ofile

      dimension d(3500000),e(3500000),dsrt(3500000),r(3500000),
     &  fmed(3500000)
      integer year(3500000),mn(3500000),ikeep(3500000),tevent(2000),
     &  nincr(30)
      double precision fjul,fday,tsam_day,time0,time,day(3500000)
    
      itmax=2000
      fmiss=9999999.
      
      nmax=3500000
      do 1 i=1,nmax
      r(i)=fmiss
      ikeep(i)=0
1     d(i)=fmiss
      print*,' Input the type of date format'
      print*,'   year julian   put 1'
      print*,'  year month day put 2'
      read(5,*)ifor
      print*,' Input file to examine'
      print*,'   input format is year, julian day, data, data_error'
      read(5,100)ifile
100   format(a20)
      open(1,file=ifile)
      print*,' Input name of output file'
      read(5,100)ofile
      open(4,file=ofile)
      print*,' Input sampling interval in days'
      print*,'   1--hour = ',1./24.d+0
      print*,'   10--minutes =',10./(24.d+0 * 60.0d+0)
      print*,'   1--minute = ',1.0/(24.d+0 * 60.0d+0)
      print*,'   1--second =', 1.0/(24.d+0 * 3600.0d+0)
      read(5,*)tsam_day
      n=0
      ic=0

2     continue
      if (ifor .eq. 1) then
        read(1,*,end=3)yr,fjul,obs,err

        call jul2day(int(yr+0.5),int(fjul+0.5),iday)


        time=float(iday)+fjul-float(int(fjul+0.5))
        if (n .eq. 0) time0=time
        n=int(((time-time0)/tsam_day)+0.5)+1
        ic=ic+1
        year(n)=yr
        day(n)=fjul

c        print*,n,n+1,year(n+1),fjul,day(n+1)


      end if
      if (ifor .eq. 2) then
        read(1,*,end=3)yr,fmn,fday,obs,err
        call  date2day(int(yr),int(fmn),int(fday+0.5),iday)
        time=float(iday)+fday-float(int(fday+0.5))
        if (n .eq. 0) time0=time

        n=int(((time-time0)/tsam_day)+0.5)+1
        ic=ic+1
        year(n)=yr
        mn(n)=int(fmn)
        day(n)=fday

      end if
c      write(2,*)n,time(n)

      d(n)=obs
      dsrt(ic)=obs
      e(n)=err


      if (n .ge. nmax) then
         print*,' Number of observations exceed dimensions'
         print*,'  nmax=',nmax,'  n=',n
         print*,n,yr,fjul,obs,time,year(n),day(n),d(n)

         stop
      end if
      
      go to 2
3     continue
     
      print*,' number of data',ic
      print*,' Total number of days ',n*tsam_day





      tstart=0


      print*,' Input the Decimation interval in days'

      read(5,*)per
      nwind=int(per/tsam_day+0.5)
      print*,'  Number of points in window', nwind
      n_tot_wind=int(n/nwind)
      print*,'  Total number of decimate data (in theory)', n_tot_wind+1
c
c  step through the data and decide which one stays and which one gets tossed
c
      idec=0
      do 10 i=1,n,nwind
        if (d(i) .ne. fmiss) then
           ikeep(i)=1
           idec=idec+1
        end if
10    continue
      print*,' Number of data from down sampling is', idec

      print*,' Input times of events where all data should be kept'
      print*,'  end list with -1 or 0'
      nevent=0
15    continue
      if (ifor .eq. 1) then
        print*,' Input event', nevent+1,' year doy'
        read(5,*,end=3)yr,fjul
        if (yr .lt. 1 ) go to 19

        call jul2day(int(yr+0.5),int(fjul+0.5),iday)

        nevent=nevent+1

        time=float(iday)+fjul-float(int(fjul+0.5))
      end if
      if (ifor .eq. 2) then
        print*,' Input event', nevent+1,' yearmnda'
        read(5,*,end=3)yr,fmn,fday
        if (yr .lt. 1 ) go to 19

        call  date2day(int(yr),int(fmn),int(fday+0.5),iday)
        time=float(iday)+fday-float(int(fday+0.5))

        nevent=nevent+1
      end if
      tevent(nevent)=int(((time-time0)/tsam_day)+0.5)+1
c      print*,time,time0,tsam_day
c      print*,(time-time0)/tsam_day, tevent(nevent)
      go to 15
19    continue
      print*,' Input the total time (days), ',
     &  'before and after event to include data' 
      read(5,*)tlen_day
 
      nlen=int(tlen_day/(2.*tsam_day))+1
 
c full sampling for first half of the window
      n2=int(nlen/2)
      nxxx=nwind-2
c      print*,tlen_day,tsam_day,'nlen=',nlen,n2,'nwind=',nwind,
c     &  'nxxx=',nxxx
c      if (nxxx .lt. 2) nxxx=2
      if ( nxxx .gt. 0 ) then
c      print*, 'am i here?'
        do 21 j=1,nxxx
        nincr(j)=j+1

21      continue
        nn=int(((nlen-n2)/nxxx)+0.5)
c        print*,' here 1',nlen, 'n2=',n2, nxxx,'nn=',nn
        else
        nxxx=1
        nincr(1)=1
        nn=n2
      end if

c
c  use full sampling at beginning and end of time series
c
      iskip=1
      print*,iskip
      if (iskip .eq. 0 ) then
        n2a=0
        do 25 k=1,n2
        ixxx=n2a+1
        if (d(ixxx) .ne. fmiss) then
          ikeep(ixxx)=1
        n2a=n2a+1
        end if
25      continue

        n2a=0
        do 26 k=1,n2
        ixxx=n-n2a
        if (d(ixxx) .ne. fmiss) then
          ikeep(ixxx)=1
          n2a=n2a+1
        end if
26      continue       
      end if
c end of skip

      do 30 i=1,nevent
c modify n2 if there is missing data
         n2a=0
         do 310 k=1,n2,1
311        continue
           ixxx=tevent(i)+n2a+k-1
c           print*,ixxx,d(ixxx),n2a,n2
           if (d(ixxx) .eq. fmiss) then
             n2a=n2a+1
             go to 311
           end if
310      continue
c         print*,tevent(i),n2a,n2
         do 31 k=1,n2a+n2,1
         ixxx=tevent(i)+k-1
         if ((ixxx .ge. 1 ) .or. (ixxx .le. nmax)) ikeep(ixxx)=1
31       continue
         iz=n2a+n2+1
c         print*,iz
         do 32 j=1,nxxx
           do 33 k=iz,nn+iz,nincr(j)
             ixxx=tevent(i)+k-1
             if ((ixxx .ge. 1 ) .or. (ixxx .le. nmax)) ikeep(ixxx)=1
33         continue

           iz=iz+nn
c           print*,j,iz
32       continue
c modify n2 if there is missing data
         n2a=0
         do 360 k=1,n2,1
361        continue
           ixxx=tevent(i)-n2a-k
c           print*,ixxx,d(ixxx),n2a,n2
           if (d(ixxx) .eq. fmiss) then
              n2a=n2a+1
              go to 361
           end if
360      continue
c         print*,tevent(i),n2a,n2
         do  36 k=1,n2a+n2,1
         ixxx=tevent(i)-k+1
         if ((ixxx .ge. 1 ) .or. (ixxx .le. nmax)) ikeep(ixxx)=1
36       continue
         iz=n2a+1+n2
c         print*,iz
         do 37 j=1,nxxx
           do 38 k=iz,nn+iz,nincr(j)
             ixxx=tevent(i)-k+1
             if ((ixxx .ge. 1 ) .or. (ixxx .le. nmax)) ikeep(ixxx)=1
38         continue
           iz=iz+nn
c         print*,j,iz
37       continue     
30    continue


c  output the results
      icc=0
      do 40 i=1,n
      if (ikeep(i) .eq. 1) then
        if (d(i) .ne. fmiss) then
          icc=icc+1
          if (ifor .eq. 1) then
             write(4,110)year(i),day(i),d(i),0.1
110          format(1x,i5,f15.9,f15.2,f7.1) 
          end if
          if (ifor .eq. 2) then
             write(4,111)year(i),mn(i),day(i),d(i),0.1
111          format(1x,i5,i4,f15.9,f15.2,f7.1)

          end if

        end if
      end if
40    continue  
      print*,' Actual number of data output is', icc     


      close (1)
      close (4)

      stop
      end





      subroutine date2day(yr,mon,date,day)
      integer yr,date,day,mon
      dimension mnth(12)
      data (mnth(i),i=1,12)/0,31,59,90,120,151,181,212,243,273,304,334/
c
      yr=yr-1900

      day=0
      day=int(yr-60)*365
      if (yr .le. 60) go to 3
      day= day+1
      if (yr .le. 64) go to 3
      day= day+1
      if (yr .le. 68) go to 3
      day= day+1
      if (yr .le. 72) go to 3
      day= day+1
      if (yr .le. 76) go to 3
      day= day+1
      if (yr .le. 80) go to 3
      day= day+1
      if (yr .le. 84) go to 3
      day=day+1
      if (yr .le. 88) go to 3
      day=day+1
      if (yr .le. 92) go to 3
      day=day+1
      if (yr .le. 96) go to 3
      day=day+1
      if (yr .le. 100) go to 3
      day=day+1     
      if (yr .le. 104) go to 3
      day=day+1     
      if (yr .le. 108) go to 3
      day=day+1     
3     day=day+mnth(mon)+date
      if (((yr .eq. 80) .or. (yr .eq. 64) .or. (yr .eq. 68) .or.
     &  (yr .eq. 72) .or. (yr .eq. 76) .or. (yr .eq. 80) .or. 
     & (yr .eq. 84) .or.(yr .eq. 88)
     &  .or. (yr .eq. 92) .or. (yr .eq. 96) .or. (yr .eq. 100)
     & .or. (yr .eq. 104) .or. (yr .eq. 108))
     1  .and. (mon .ge. 3)) go to 10
      go to 11
10    day= day+1
      
11    continue
      yr=yr+1900
      return
      end
      
      subroutine jul2day(yr,jul,iday)
      integer yr, jul, iday
      yr=yr-1900
      iday=0
      if (yr .gt. 60 ) iday=iday+1
      if (yr .gt. 64 ) iday=iday+1
      if (yr .gt. 68 ) iday=iday+1
      if (yr .gt. 72 ) iday=iday+1
      if (yr .gt. 76 ) iday=iday+1
      if (yr .gt. 80 ) iday=iday+1
      if (yr .gt. 84 ) iday=iday+1
      if (yr .gt. 88 ) iday=iday+1
      if (yr .gt. 92 ) iday=iday+1
      if (yr .gt. 96 ) iday=iday+1
      if (yr .gt. 100 ) iday=iday+1
      if (yr .gt. 104 ) iday=iday+1
      if (yr .gt. 108 ) iday=iday+1

      iday=iday+(yr-60)*365 + jul
      yr=yr+1900
      return
      end
      subroutine inv_jul_time(itime,nyr,jul)
c converts day number since jan 1, 1960 back to julian day and year
c
c  itime is number of days since Jan 1, 1960
      dimension nyear(60),nleap(60)
      nx=60
        do 1 i=1,nx
        nleap(i)=1+(i-1)*4
1       continue
        j=1
        ncnt=0
        do 2 i=1,nx
        if (i .eq. nleap(j)) then
           ncnt=ncnt+366
           j=j+1
        else
          ncnt=ncnt+365
        end if
        nyear(i)=ncnt
c        print*,i,nyear(i)
2       continue
      k=1
      nyr=1960
c      if (itime .lt. nyear(1)) then
      if (itime .le. nyear(1)) then
        jul=itime
        return
      end if
      k=2
      nyr=nyr+1
3     continue
      if ((itime .gt. nyear(k-1)) .and. (itime .le. nyear(k))) then
        jul=itime-nyear(k-1)
        return
      else
        k=k+1
        nyr=nyr+1
        go to 3
      end if
      end
